import React, { useState, useContext, forwardRef } from 'react'
import FormRender, { useForm } from 'form-render'
import { ConfigProvider } from 'antd'
import widgets from '../widgets'

const XRender = (props, ref) => {

  const { schema } = props

  const { getPrefixCls } = useContext(ConfigProvider.ConfigContext)
  const prefixCls = getPrefixCls('pandaXform')
  const pandaXform = getPrefixCls()

  const [extraData, setExtraData] = useState({})
  const [parseFormData, setParseFormData] = useState({})
  const [listData, setListData] = useState([])
  const form = useForm()

  const onClick = () => {
    console.log('form', form, form.getValues())
  }

  return (
    <div className={prefixCls} onClick={() => onClick()}>
      <FormRender
        configProvider={{ prefixCls: pandaXform }}
        form={form}
        schema={schema}
        // onChange={form.setValues}
        mapping={{
          object: 'Header',
        }}
        widgets={widgets}
      />
    </div>
  )

}


export default forwardRef(XRender)
