// 可编辑值选择器
import React, { useState, useEffect } from 'react';
import { Select } from 'antd';

const { Option } = Select;

const EditSelect = ({ value, onChange, schema }) => {

  const { disabled, placeholder } = schema

  const children = [];
  for (let i = 0; i < schema.enum.length; i++) {
    children.push(<Option key={i.toString(36) + i}>{schema.enum[i]}</Option>);
  }
  const val = value || schema.default;
  useEffect(() => {
    onChange(val);
  }, []);
  return (
    <Select
      disabled={disabled}
      showArrow={!disabled}
      placeholder={placeholder}
      mode={'tags'}
      value={value ? value.split(',') : []}
      onChange={val => {
        onChange(val.join(','))
      }}
      style={{ width: '100%' }}
    >
      {children}
    </Select>
  );
};

export default EditSelect;
