import React, { useEffect, useMemo } from 'react'
import { InputNumber } from 'antd'

const NumberInput = (props) => {

  const { value, onChange, schema } = props
  const { disabled, presetValue, placeholder, prefix, formatter } = schema

  useEffect(() => {
    onChange(presetValue)
  }, [presetValue, formatter])

  return (
    <InputNumber
      defaultValue={null}
      prefix={prefix}
      placeholder={placeholder}
      disabled={disabled}
      value={value}
      formatter={(value) => value && formatter ? `${value}${formatter}` : value}
      parser={(value) => value && formatter && value.replace(formatter, '')}
      onChange={value => onChange(value)}
      style={{ width: '100%' }}
    />
  )

}

export default NumberInput