import React, { useState, useEffect, useMemo } from 'react'
import { Input, message } from 'antd'
import Icon, { EllipsisOutlined } from '@ant-design/icons'
import * as icons from '@ant-design/icons'
import { GetFieldValueFromTable } from '../../../../apis/process'

const iconList = Object.keys(icons).filter((item) => typeof icons[item] === 'object')

const TextInput = (props) => {

  const userInfo = window?.globalConfig?.userInfo || { fullName: '【本人姓名】', depart: { name: '【本人部门】' } }

  const { value, onChange, schema, addons } = props
  const { disabled, placeholder, presetValue, addonBefore, addonAfter, maxLength, rules, uniqueVerify, tableName, fieldName } = schema

  // const [fields, setFields] = useState([])
  // const [uniqueRules, setUniqueRules] = useState([])

  // const uniqueRules = useMemo(() => {
  //   if (uniqueVerify === '表名/字段名') {
  //     if (tableName && fieldName) {
  //       return [
  //         {
  //           validator: async (rule, value, callback) => {
  //             console.log('validator', value)
  //             const { code, data, msg } = await GetFieldValueFromTable(tableName, fieldName)
  //             if (code === 0) {
  //               if (!disabled && res.data.includes(value)) {
  //                 callback(new Error(`${12}已重复，请重新输入`));
  //               }
  //             }
  //             callback()
  //           }
  //         }
  //       ]
  //     }
  //   }
  //   return []
  // }, [uniqueVerify, tableName, fieldName])

  // const inputRules = useMemo(() => {
  //   let array = Array.isArray(rules) ? rules : []
  //   return array.concat(uniqueRules)
  // }, [rules, uniqueRules])

  useEffect(() => {
    if (addons) {
      addons.setValue(addons.dataPath, presetValue)
    } else {
      onChange(presetValue)
    }
  }, [presetValue])

  const style = useMemo(() => {
    let paths = ['【本人姓名】', '【本人部门】']
    if (paths.includes(value)) {
      if (value === '【本人姓名】') {
        onChange(userInfo.fullName)
      } else if (value === '【本人部门】') {
        onChange(userInfo.depart.name)
      }
      return { color: 'blue' }
    }
    return null
  }, [value])

  const handleChange = (e) => {
    if (addons) {
      onChange(e.target.value)
      // addons.setValue(addons.dataPath, e.target.value)
    }
  }

  // useEffect(async () => {
  //   if (uniqueVerify === '表名/字段名') {
  //     if (tableName && fieldName) {
  //       setUniqueRules([
  //         {
  //           validator: async (rule, value, callback) => {
  //             const { code, data, msg } = await GetFieldValueFromTable(tableName, fieldName)
  //             if (code === 0) {
  //               if (!disabled && res.data.includes(value)) {
  //                 callback(new Error(`${dataObj.alias}已重复，请重新输入`));
  //               }
  //             }
  //             callback()
  //           }
  //         }
  //       ])
  //       // const { code, data, msg } = await GetFieldValueFromTable(tableName, fieldName)
  //       // if (code === 0) {
  //       //   if (Array.isArray(data)) {

  //       //     setFields(data)
  //       //   } else {
  //       //     setFields([])
  //       //   }
  //       // } else {
  //       //   message.error(msg)
  //       // }
  //     }
  //   }
  // }, [uniqueVerify, disabled])

  return (
    <Input
      style={style}
      // rules={inputRules}
      disabled={disabled}
      value={value}
      maxLength={maxLength}
      placeholder={disabled ? null : placeholder}
      onChange={handleChange}
      addonBefore={iconList.includes(addonBefore) ? <Icon component={icons[addonBefore]} /> : addonBefore}
      addonAfter={iconList.includes(addonAfter) ? <Icon component={icons[addonAfter]} /> : addonAfter}
    />
  )

}

export default TextInput
